/'
 Constants.bi
 
 Contains a lot of consts, that are needed at the one or another time, with a nice symbol that says much more than 
 a number.
 
 Contents:
 
 - Keycodes: Most common Keycodes like arrow keys, F-Keys (incl. Shift-, Ctrl-, Alt-Versions),
   , , , ...
   
 - Colors: Symbol names contain the color in its spoken form. CL_Red contains &HFF0000, the Hex-Code for red.
   There are 8bit and 4bit-Versions, too.
   For 32bit-Colors, the Symbol is CL_ + Color
   For  8bit-Colors, the Symbol is C8_ + Color. C8-Colors begin at idx 16.
      There are also the Symbols C8_medSat, C8_lowSat, C8_medBrg and the C8_lowBrg, that can be
      added to the C8_ Basic symbols, to chose the band.
      For Example, this would be Green in medium brightness and low saturation:
         C8_Green + C8_medBrg + C8_lowInt
   For  4bit-Colors, the Symbol is C4_ + Color.
      
 
 See also Constants in:
   - vbcompat.bi
   - datetime.bi
   - string.bi
   - dir.bi
   - file.bi
'/

#Include "fbgfx.bi"

'  Misc
#Define pi        ( 4# * Atn(1#) )
#Define True      -1
#Define False     0
'------------------------------------------------------------------------------'
' KeyCodes

#Define kc_Back             Chr(  8)
#Define kc_Tab              Chr(  9)
#Define kc_Lf               Chr( 10)
#Define kc_Cr               Chr( 13)
#Define kc_Esc              Chr( 27)
#Define kc_Spc              Chr( 32)
#Define kc_QM               Chr( 34)
#Define kc_CrLf             Chr( 13, 10)
#Define kc_Return           kc_Cr
#Define kc_Enter            kc_Cr

#Define FKey                Chr(255)

#Define kc_Left      FKey + Chr( 75)   ' K
#Define kc_Right     FKey + Chr( 77)   ' M
#Define kc_Up        FKey + Chr( 72)   ' H
#Define kc_Down      FKey + Chr( 80)   ' P
#Define kc_Pos1      FKey + Chr( 71)   ' G
#Define kc_End       FKey + Chr( 79)   ' O
#Define kc_Ins       FKey + Chr( 82)   ' R
#Define kc_Del       FKey + Chr( 83)   ' S

#Define kc_GAE              Chr(142)   '  / 
#Define kc_KAE              Chr(132)   '  / 
#Define kc_GOE              Chr(153)   '  / 
#Define kc_KOE              Chr(148)   '  / 
#Define kc_GUE              Chr(154)   '  / 
#Define kc_KUE              Chr(129)   '  / 
#Define kc_S                Chr(225)   '  / 

#Define kc_F1        FKey + Chr( 59)   ' ;
#Define kc_F2        FKey + Chr( 60)   ' <
#Define kc_F3        FKey + Chr( 61)   ' =
#Define kc_F4        FKey + Chr( 62)   ' >
#Define kc_F5        FKey + Chr( 63)   ' ?
#Define kc_F6        FKey + Chr( 64)   ' @
#Define kc_F7        FKey + Chr( 65)   ' A
#Define kc_F8        FKey + Chr( 66)   ' B
#Define kc_F9        FKey + Chr( 67)   ' C
#Define kc_F10       FKey + Chr( 68)   ' D
#Define kc_F11       FKey + Chr(133)   ' 
#Define kc_F12       FKey + Chr(134)   ' 

#Define kc_ShiftF1   FKey + Chr( 84)   ' T
#Define kc_ShiftF2   FKey + Chr( 85)   ' U
#Define kc_ShiftF3   FKey + Chr( 86)   ' V
#Define kc_ShiftF4   FKey + Chr( 87)   ' W
#Define kc_ShiftF5   FKey + Chr( 88)   ' X
#Define kc_ShiftF6   FKey + Chr( 89)   ' Y
#Define kc_ShiftF7   FKey + Chr( 90)   ' Z
#Define kc_ShiftF8   FKey + Chr( 91)   ' [
#Define kc_ShiftF9   FKey + Chr( 92)   ' \
#Define kc_ShiftF10  FKey + Chr( 93)   ' ]
#Define kc_ShiftF11  FKey + Chr(135)   ' 
#Define kc_ShiftF12  FKey + Chr(136)   ' 

#Define kc_CtrlF1    FKey + Chr( 94)   ' ^
#Define kc_CtrlF2    FKey + Chr( 95)   ' _
#Define kc_CtrlF3    FKey + Chr( 96)   ' 
#Define kc_CtrlF4    FKey + Chr( 97)   ' a
#Define kc_CtrlF5    FKey + Chr( 98)   ' b
#Define kc_CtrlF6    FKey + Chr( 99)   ' c
#Define kc_CtrlF7    FKey + Chr(100)   ' d
#Define kc_CtrlF8    FKey + Chr(101)   ' e
#Define kc_CtrlF9    FKey + Chr(102)   ' f
#Define kc_CtrlF10   FKey + Chr(103)   ' g
#Define kc_CtrlF11   FKey + Chr(137)   ' 
#Define kc_CtrlF12   FKey + Chr(138)   ' 

#Define kc_AltF1     FKey + Chr(104)   ' h
#Define kc_AltF2     FKey + Chr(105)   ' i
#Define kc_AltF3     FKey + Chr(106)   ' j
#Define kc_AltF4     FKey + Chr(107)   ' k
#Define kc_AltF5     FKey + Chr(108)   ' l
#Define kc_AltF6     FKey + Chr(109)   ' m
#Define kc_AltF7     FKey + Chr(110)   ' n
#Define kc_AltF8     FKey + Chr(111)   ' o
#Define kc_AltF9     FKey + Chr(112)   ' p
#Define kc_AltF10    FKey + Chr(113)   ' q
#Define kc_AltF11    FKey + Chr(139)   ' 
#Define kc_AltF12    FKey + Chr(140)   ' 
'------------------------------------------------------------------------------'
' Colors
'  For 24/32 bpp-modes
#Define CL_Black        &H000000
#Define CL_D_Gray       &H888888
#Define CL_M_Gray       &HBBBBBB
#Define CL_L_Gray       &HDDDDDD
#Define CL_White        &HFFFFFF

#Define CL_Red          &HFF0000
#Define CL_Green        &H00FF00
#Define CL_Blue         &H0000FF
#Define CL_Yellow       &HFFFF00
#Define CL_Cyan         &H00FFFF
#Define CL_Pink         &HFF00FF
#Define CL_Orange       &HFF8800
#Define CL_Mint         &H00FF88
#Define CL_Violett      &H8800FF
#Define CL_Rosa         &HFF0088
#Define CL_YellowGreen  &H88FF00
#Define CL_SkyBlue      &H0088FF
#Define CL_D_Red        &H880000
#Define CL_D_Green      &H008800
#Define CL_D_Blue       &H000088
#Define CL_D_Yellow     &H888800
#Define CL_D_Cyan       &H008888
#Define CL_D_Pink       &H880088
#Define CL_L_Red        &HFF8888
#Define CL_L_Green      &H88FF88
#Define CL_L_Blue       &H8888FF
#Define CL_L_Yellow     &HFFFF88
#Define CL_L_Cyan       &H88FFFF
#Define CL_L_Pink       &HFF88FF
'..............................................................................'
'    For 4/8bpp-modes
#Define C4_Black        &H00        '   0
#Define C4_Blue         &H01        '   1
#Define C4_Green        &H02        '   2
#Define C4_Cyan         &H03        '   3
#Define C4_Red          &h04        '   4
#Define C4_Magenta      &H05        '   5
#Define C4_Brown        &H06        '   6
#Define C4_White        &H07        '   7
   #Define C4_B_Gray    &H07
#Define C4_Gray         &H08        '   8
   #Define C4_D_Gray    &H08
#Define C4_B_Blue       &H09        '   9
#Define C4_B_Green      &H0A        '  10
#Define C4_B_Cyan       &H0B        '  11
#Define C4_B_Red        &H0C        '  12
   #Define C4_Rosa      &H0C
#Define C4_B_Magenta    &H0D        '  13
   #Define C4_Pink      &H0D
#Define C4_B_Brown      &H0E        '  14
   #Define C4_Yellow    &H0E
#Define C4_B_White      &H0F        '  15
'..............................................................................'
'    For 8bit-modes only (not for Text-modes)
#Define C8_Black        &H10        '  16
#Define C8_D_Gray       &H14        '  20
#Define C8_M_Gray       &H18        '  24
#Define C8_B_Gray       &H1C        '  28
#Define C8_White        &H1F        '  31

#Define C8_Blue         &H20        '  32
#Define C8_Pink         &H24        '  36
#Define C8_Red          &H28        '  40
#Define C8_Yellow       &H2C        '  44
#Define C8_Green        &H30        '  48
#Define C8_Cyan         &H34        '  52

#Define C8_medSat       &H18        '  24
#Define C8_lowSat       &H30        '  48

#Define C8_medBrg       &H48        '  72
#Define C8_lowBrg       &H90        ' 144