' Divorcing Lines
'=============================================================================='
'------------------------------------------------------------------------------'
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~'
'******************************************************************************'
'++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++'
'::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::'
'..............................................................................'

'=============================================================================='
#If Not Defined(CommonInc_Standards ) And _
    Not Defined(CommonInc_ShortWords) And _
    Not Defined(CommonInc_Constants ) And _
    Not Defined(CommonInc_Macros    ) And _
    Not Defined(CommonInc_DrwTxtCtrl) And _
    Not Defined(CommonInc_DrwGfxCtrl) And _
    Not Defined(CommonInc_GfxString )
      
      #Print
      #Print No specification what to include - including all packs of CommonStatements.
      #Print Use Include-Flags to specify which packs should be included.
      #Print Syntax:
      #Print ...#DEFINE %include-flag%
      #Print
      #Print %include-flag% is one of these flags:
      #Print ...CommonInc_All, CommonInc_Standards, CommonInc_ShortWords, CommonInc_Constants, CommonInc_Macros, CommonInc_DrwTxtCtrl, CommonInc_DrwGfxCtrl, CommonInc_GfxString
      #Print
      
      #Define CommonInc_All
#EndIf

#IfDef CommonInc_All
   #Define CommonInc_Standards
   #Define CommonInc_ShortWords
   #Define CommonInc_Constants
   #Define CommonInc_Macros
   #Define CommonInc_DrwTxtCtrl
   #Define CommonInc_DrwGfxCtrl
   #Define CommonInc_GfxString
#EndIf


#IfDef CommonInc_Standards
   #IfDef __FB_LANG__
      #If __FB_LANG__ <> "fb"
         Option Explicit
         Option Dynamic
         Option ByVal
      #EndIf
   #Else
         Option Explicit
         Option Dynamic
         Option ByVal
   #Endif

   Randomize Timer
   
   #Include "vbcompat.bi"
      /' containing:
         - datetime.bi
         - string.bi
         - dir.bi
         - file.bi
      '/
   #Include "fbgfx.bi"
   #Include "utf_conv.bi"
#EndIf

#IfDef CommonInc_ShortWords
   #Include once "CommonStatements/ShortWords.bi"
#EndIf

#IfDef CommonInc_Constants
   #Include once "CommonStatements/Constants.bi"
#EndIf

#IfDef CommonInc_Macros
   #Define CommonInc_ShortWords
   
   #Include once "CommonStatements/ShortWords.bi"
   #Include once "CommonStatements/Macro.bi"
#EndIf

#IfDef CommonInc_GfxString
   #Define CommonInc_ShortWords
   
   #Include once "CommonStatements/ShortWords.bi"
   #Include once "CommonStatements/GfxString.bi"
#EndIf

#IfDef CommonInc_DrwTxtCtrl
   #Define CommonInc_ShortWords
   #Define CommonInc_Macros
   #Define CommonInc_GfxString
   
   #Include once "CommonStatements/ShortWords.bi"
   #Include once "CommonStatements/Macro.bi"
   #Include once "CommonStatements/DrwTxtCtrl.bi"
#EndIf

#IfDef CommonInc_DrwGfxCtrl
   #Define CommonInc_Constants
   #Define CommonInc_ShortWords
   #Define CommonInc_Macros
   #Define CommonInc_GfxString
   
   #Include once "CommonStatements/Constants.bi"
   #Include once "CommonStatements/ShortWords.bi"
   #Include once "CommonStatements/Macro.bi"
   #Include once "CommonStatements/GfxString.bi"
   #Include once "CommonStatements/DrwGfxCtrl.bi"
#EndIf
